## gudhi 3.7.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(GUDHIdev)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/src/cmake/modules/")
include(CMakeGUDHIVersion.txt)
include(GUDHI_options)

# Reset cache
set(GUDHI_MODULES "" CACHE INTERNAL "GUDHI_MODULES")
set(GUDHI_MISSING_MODULES "" CACHE INTERNAL "GUDHI_MISSING_MODULES")

# This variable is used by Cython CMakeLists.txt and by GUDHI_third_party_libraries to know its path
set(GUDHI_PYTHON_PATH "src/python")

include(GUDHI_submodules)

if (WITH_GUDHI_THIRD_PARTY)
  # For third parties libraries management - To be done last as CGAL updates CMAKE_MODULE_PATH
  include(GUDHI_third_party_libraries NO_POLICY_SCOPE)
endif()

include(GUDHI_compilation_flags)

# Add your new module in the list, order is not important
include(GUDHI_modules)

add_gudhi_module(common)
add_gudhi_module(Alpha_complex)
add_gudhi_module(Bitmap_cubical_complex)
add_gudhi_module(Bottleneck_distance)
add_gudhi_module(Collapse)
add_gudhi_module(Contraction)
add_gudhi_module(Coxeter_triangulation)
add_gudhi_module(Cech_complex)
add_gudhi_module(Hasse_complex)
add_gudhi_module(Persistence_representations)
add_gudhi_module(Persistent_cohomology)
add_gudhi_module(Rips_complex)
add_gudhi_module(Simplex_tree)
add_gudhi_module(Skeleton_blocker)
add_gudhi_module(Spatial_searching)
add_gudhi_module(Subsampling)
add_gudhi_module(Tangential_complex)
add_gudhi_module(Toplex_map)
add_gudhi_module(Witness_complex)
add_gudhi_module(Nerve_GIC)

# Include module CMake subdirectories
# GUDHI_SUB_DIRECTORIES is managed in CMAKE_MODULE_PATH/GUDHI_modules.cmake
foreach(GUDHI_MODULE ${GUDHI_MODULES})
  foreach(GUDHI_SUB_DIRECTORY ${GUDHI_SUB_DIRECTORIES})
    if(EXISTS ${CMAKE_SOURCE_DIR}/src/${GUDHI_MODULE}/${GUDHI_SUB_DIRECTORY}/CMakeLists.txt)
      add_subdirectory(src/${GUDHI_MODULE}/${GUDHI_SUB_DIRECTORY}/)
    endif()
  endforeach()
endforeach()

if (WITH_GUDHI_THIRD_PARTY)
  add_subdirectory(src/GudhUI)
endif()

if (WITH_GUDHI_PYTHON)
  # specific for cython module
  add_subdirectory(${GUDHI_PYTHON_PATH})
else()
  message("++ Python module will not be compiled because WITH_GUDHI_PYTHON is set to OFF")
  set(GUDHI_MISSING_MODULES ${GUDHI_MISSING_MODULES} "python")
endif()

# For "make user_version" - Requires GUDHI_modules to be performed
include(GUDHI_user_version_target)
# For "make doxygen" - Requires GUDHI_USER_VERSION_DIR to be set - Done in GUDHI_user_version_target for dev version
include(GUDHI_doxygen_target)

configure_file(${CMAKE_SOURCE_DIR}/.github/for_maintainers/new_gudhi_version_creation.md "${CMAKE_CURRENT_BINARY_DIR}/" @ONLY)

message("++ GUDHI_MODULES list is:\"${GUDHI_MODULES}\"")
message("++ GUDHI_MISSING_MODULES list is:\"${GUDHI_MISSING_MODULES}\"")

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(GUDHI)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
include(CMakeGUDHIVersion.txt)
include(GUDHI_options)

set(GUDHI_MODULES "" CACHE INTERNAL "GUDHI_MODULES")
set(GUDHI_MISSING_MODULES "" CACHE INTERNAL "GUDHI_MISSING_MODULES")

# This variable is used by Cython CMakeLists.txt and by GUDHI_third_party_libraries to know its path
set(GUDHI_PYTHON_PATH "python")

include(GUDHI_submodules)

if (WITH_GUDHI_THIRD_PARTY)
  # For third parties libraries management - To be done last as CGAL updates CMAKE_MODULE_PATH
  include(GUDHI_third_party_libraries NO_POLICY_SCOPE)
endif()

include(GUDHI_compilation_flags)

# Add your new module in the list, order is not important
include(GUDHI_modules)

add_gudhi_module(common)
add_gudhi_module(Alpha_complex)
add_gudhi_module(Bitmap_cubical_complex)
add_gudhi_module(Bottleneck_distance)
add_gudhi_module(Cech_complex)
add_gudhi_module(Contraction)
add_gudhi_module(Collapse)
add_gudhi_module(Coxeter_triangulation)
add_gudhi_module(Hasse_complex)
add_gudhi_module(Persistence_representations)
add_gudhi_module(Persistent_cohomology)
add_gudhi_module(Rips_complex)
add_gudhi_module(Simplex_tree)
add_gudhi_module(Skeleton_blocker)
add_gudhi_module(Spatial_searching)
add_gudhi_module(Subsampling)
add_gudhi_module(Tangential_complex)
add_gudhi_module(Toplex_map)
add_gudhi_module(Witness_complex)
add_gudhi_module(Nerve_GIC)

# For "make doxygen" - Requires GUDHI_USER_VERSION_DIR to be set
set(GUDHI_USER_VERSION_DIR ${CMAKE_SOURCE_DIR})
include(GUDHI_doxygen_target)

#---------------------------------------------------------------------------------------
# Gudhi compilation part
include_directories(include)

# Include module CMake subdirectories
# GUDHI_SUB_DIRECTORIES is managed in CMAKE_MODULE_PATH/GUDHI_modules.cmake
if (WITH_GUDHI_PYTHON)
  # specific for cython module
  add_subdirectory(${GUDHI_PYTHON_PATH})
else()
  message("++ Python module will not be compiled because WITH_GUDHI_PYTHON is set to OFF")
  set(GUDHI_MISSING_MODULES ${GUDHI_MISSING_MODULES} "python")
endif()

foreach(GUDHI_MODULE ${GUDHI_MODULES})
  foreach(GUDHI_SUB_DIRECTORY ${GUDHI_SUB_DIRECTORIES})
    if(EXISTS ${CMAKE_SOURCE_DIR}/${GUDHI_SUB_DIRECTORY}/${GUDHI_MODULE}/CMakeLists.txt)
      add_subdirectory(${CMAKE_SOURCE_DIR}/${GUDHI_SUB_DIRECTORY}/${GUDHI_MODULE}/)
    endif()
  endforeach()
endforeach()

if (WITH_GUDHI_THIRD_PARTY)
  add_subdirectory(GudhUI)
endif()

message("++ GUDHI_MODULES list is:\"${GUDHI_MODULES}\"")
message("++ GUDHI_MISSING_MODULES list is:\"${GUDHI_MISSING_MODULES}\"")

#---------------------------------------------------------------------------------------

#---------------------------------------------------------------------------------------
# GUDHIConfig.cmake
# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE GUDHI)

message("++ make install will install ${PROJECT_NAME} in the following directory : ${CMAKE_INSTALL_PREFIX}")
# Create the GUDHIConfig.cmake and GUDHIConfigVersion files
set(CONF_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/include;${CMAKE_INSTALL_PREFIX}/include")
configure_file(GUDHIConfig.cmake.in "${PROJECT_BINARY_DIR}/GUDHIConfig.cmake" @ONLY)
configure_file(GUDHIConfigVersion.cmake.in "${PROJECT_BINARY_DIR}/GUDHIConfigVersion.cmake" @ONLY)

#---------------------------------------------------------------------------------------

#---------------------------------------------------------------------------------------
# Gudhi installation part

# Install the GUDHIConfig.cmake and GUDHIConfigVersion.cmake
install(FILES
  "${PROJECT_BINARY_DIR}/GUDHIConfig.cmake"
  "${PROJECT_BINARY_DIR}/GUDHIConfigVersion.cmake"
  DESTINATION share/gudhi)

# install the include file on "make install"
install(DIRECTORY include/gudhi DESTINATION include)
#---------------------------------------------------------------------------------------

=== src/python/CMakeLists.txt ===
project(Cython)

function( add_GUDHI_PYTHON_lib THE_LIB )
  if(EXISTS ${THE_LIB})
    get_filename_component(THE_LIB_FILE_NAME ${THE_LIB} NAME_WE)
    if(WIN32)
      message("++ ${THE_LIB} => THE_LIB_FILE_NAME = ${THE_LIB_FILE_NAME}")
      set(GUDHI_PYTHON_LIBRARIES "${GUDHI_PYTHON_LIBRARIES}'${THE_LIB_FILE_NAME}', " PARENT_SCOPE)
    else(WIN32)
      STRING(REGEX REPLACE "lib" "" UNIX_LIB_FILE_NAME ${THE_LIB_FILE_NAME})
      message("++ ${THE_LIB} => UNIX_LIB_FILE_NAME = ${UNIX_LIB_FILE_NAME}")
      set(GUDHI_PYTHON_LIBRARIES "${GUDHI_PYTHON_LIBRARIES}'${UNIX_LIB_FILE_NAME}', " PARENT_SCOPE)
    endif(WIN32)
  endif(EXISTS ${THE_LIB})
endfunction( add_GUDHI_PYTHON_lib )

function( add_GUDHI_PYTHON_lib_dir)
  # Argument may be a list (specifically on windows with release/debug paths)
  foreach(THE_LIB_DIR IN LISTS ARGN)
    # deals when it is not set - error on windows
    if(EXISTS ${THE_LIB_DIR})
      set(GUDHI_PYTHON_LIBRARY_DIRS "${GUDHI_PYTHON_LIBRARY_DIRS}'${THE_LIB_DIR}', " PARENT_SCOPE)
    else()
      message("add_GUDHI_PYTHON_lib_dir - '${THE_LIB_DIR}' does not exist")
    endif()
  endforeach()
endfunction( add_GUDHI_PYTHON_lib_dir )

# THE_TEST is the python test file name (without .py extension) containing tests functions
function( add_gudhi_py_test THE_TEST )
  if(PYTEST_FOUND)
    # use ${PYTHON_EXECUTABLE} -B, otherwise a __pycache__ directory is created in sources by python
    # use py.test no cache provider, otherwise a .cache file is created in sources by py.test
    add_test(NAME ${THE_TEST}_py_test
             WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
             COMMAND ${PYTHON_EXECUTABLE} -B -m pytest -p no:cacheprovider ${CMAKE_CURRENT_SOURCE_DIR}/test/${THE_TEST}.py)
  endif()
endfunction( add_gudhi_py_test )

# Set gudhi.__debug_info__
# WARNING : to be done before setup.py.in configure_file
function( add_gudhi_debug_info DEBUG_INFO )
  set(GUDHI_PYTHON_DEBUG_INFO "${GUDHI_PYTHON_DEBUG_INFO}    \"${DEBUG_INFO}\\n\" \\\n" PARENT_SCOPE)
endfunction( add_gudhi_debug_info )

if(PYTHONINTERP_FOUND)
  if(NUMPY_FOUND AND PYBIND11_FOUND AND CYTHON_FOUND)
    add_gudhi_debug_info("Pybind11 version ${PYBIND11_VERSION}")
    # PyBind11 modules
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'bottleneck', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'hera', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'clustering', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'datasets', ")

    # Cython modules
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'off_utils', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'simplex_tree', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'rips_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'cubical_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'periodic_cubical_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'persistence_graphical_tools', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'reader_utils', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'witness_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'strong_witness_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'nerve_gic', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'subsampling', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'tangential_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'alpha_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'euclidean_witness_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'euclidean_strong_witness_complex', ")
    # Modules that should not be auto-imported in __init__.py
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'representations', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'tensorflow', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'wasserstein', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'point_cloud', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'weighted_rips_complex', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'dtm_rips_complex', ")

    add_gudhi_debug_info("Python version ${PYTHON_VERSION_STRING}")
    add_gudhi_debug_info("Cython version ${CYTHON_VERSION}")
    if(PYTEST_FOUND)
      add_gudhi_debug_info("Pytest version ${PYTEST_VERSION}")
    endif()
    if(MATPLOTLIB_FOUND)
      add_gudhi_debug_info("Matplotlib version ${MATPLOTLIB_VERSION}")
    endif()
    if(NUMPY_FOUND)
      add_gudhi_debug_info("Numpy version ${NUMPY_VERSION}")
    endif()
    if(SCIPY_FOUND)
      add_gudhi_debug_info("Scipy version ${SCIPY_VERSION}")
    endif()
    if(SKLEARN_FOUND)
      add_gudhi_debug_info("Scikit-learn version ${SKLEARN_VERSION}")
    endif()
    if(OT_FOUND)
      add_gudhi_debug_info("POT version ${OT_VERSION}")
    endif()
    if(HNSWLIB_FOUND)
      # Does not have a version number...
      add_gudhi_debug_info("HNSWlib found")
    endif()
    if(TORCH_FOUND)
      add_gudhi_debug_info("PyTorch version ${TORCH_VERSION}")
    endif()
    if(PYKEOPS_FOUND)
      add_gudhi_debug_info("PyKeOps version ${PYKEOPS_VERSION}")
    endif()
    if(EAGERPY_FOUND)
      add_gudhi_debug_info("EagerPy version ${EAGERPY_VERSION}")
    endif()
    if(TENSORFLOW_FOUND)
      add_gudhi_debug_info("TensorFlow version ${TENSORFLOW_VERSION}")
    endif()
    if(SPHINX_FOUND)
      add_gudhi_debug_info("Sphinx version ${SPHINX_VERSION}")
    endif()
    if(SPHINX_PARAMLINKS_FOUND)
      add_gudhi_debug_info("Sphinx-paramlinks version ${SPHINX_PARAMLINKS_VERSION}")
    endif()
    if(PYTHON_DOCS_THEME_FOUND)
      # Does not have a version number...
      add_gudhi_debug_info("python_docs_theme found")
    endif()

    set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DBOOST_RESULT_OF_USE_DECLTYPE', ")
    set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DBOOST_ALL_NO_LIB', ")
    set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DBOOST_SYSTEM_NO_DEPRECATED', ")

    # Gudhi and CGAL compilation option
    if(MSVC)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'/std:c++17', ")
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'/fp:strict', ")
    else(MSVC)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-std=c++17', ")
    endif(MSVC)
    if(CMAKE_COMPILER_IS_GNUCXX)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-frounding-math', ")
      set(GUDHI_PYBIND11_EXTRA_COMPILE_ARGS "${GUDHI_PYBIND11_EXTRA_COMPILE_ARGS}'-fvisibility=hidden', ")
    endif(CMAKE_COMPILER_IS_GNUCXX)
    if (CMAKE_CXX_COMPILER_ID MATCHES Intel)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-fp-model strict', ")
    endif(CMAKE_CXX_COMPILER_ID MATCHES Intel)
    if (DEBUG_TRACES)
      # For programs to be more verbose
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DDEBUG_TRACES', ")
    endif()

    if (EIGEN3_FOUND)
      add_gudhi_debug_info("Eigen3 version ${EIGEN3_VERSION}")
      # No problem, even if no CGAL found
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_EIGEN3_ENABLED', ")
    endif (EIGEN3_FOUND)

    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'off_utils', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'simplex_tree', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'rips_complex', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'cubical_complex', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'periodic_cubical_complex', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'reader_utils', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'witness_complex', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'strong_witness_complex', ")
    set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'clustering/_tomato', ")
    set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'hera/wasserstein', ")
    set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'hera/bottleneck', ")
    set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'nerve_gic', ")
    if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
      set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'datasets/generators/_points', ")
      set(GUDHI_PYBIND11_MODULES "${GUDHI_PYBIND11_MODULES}'bottleneck', ")
    endif ()
    if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)
      set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'subsampling', ")
      set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'tangential_complex', ")
      set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'euclidean_witness_complex', ")
      set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'euclidean_strong_witness_complex', ")
    endif ()
    if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.1.0)
      set(GUDHI_CYTHON_MODULES "${GUDHI_CYTHON_MODULES}'alpha_complex', ")
    endif ()

    # from windows vcpkg eigen 3.4.0#2 : build fails with
    # error C2440: '<function-style-cast>': cannot convert from 'Eigen::EigenBase<Derived>::Index' to '__gmp_expr<mpq_t,mpq_t>'
    # cf. https://gitlab.com/libeigen/eigen/-/issues/2476
    # Workaround is to compile with '-DEIGEN_DEFAULT_DENSE_INDEX_TYPE=int'
    if (FORCE_EIGEN_DEFAULT_DENSE_INDEX_TYPE_TO_INT)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DEIGEN_DEFAULT_DENSE_INDEX_TYPE=int', ")
    endif()


    add_gudhi_debug_info("Boost version ${Boost_VERSION}")
    if(CGAL_FOUND)
      if(NOT CGAL_VERSION VERSION_LESS 5.3.0)
        # CGAL_HEADER_ONLY has been dropped for CGAL >= 5.3. Only the header-only version is supported.
        set(CGAL_HEADER_ONLY True)
      endif(NOT CGAL_VERSION VERSION_LESS 5.3.0)
      # Add CGAL compilation args
      if(CGAL_HEADER_ONLY)
        add_gudhi_debug_info("CGAL header only version ${CGAL_VERSION}")
        set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_HEADER_ONLY', ")
      else(CGAL_HEADER_ONLY)
        add_gudhi_debug_info("CGAL version ${CGAL_VERSION}")
        add_GUDHI_PYTHON_lib("${CGAL_LIBRARY}")
        add_GUDHI_PYTHON_lib_dir(${CGAL_LIBRARIES_DIR})
        message("** Add CGAL ${CGAL_LIBRARIES_DIR}")
        # If CGAL is not header only, CGAL library may link with boost system,
        if(CMAKE_BUILD_TYPE MATCHES Debug)
          add_GUDHI_PYTHON_lib("${Boost_SYSTEM_LIBRARY_DEBUG}")
        else()
          add_GUDHI_PYTHON_lib("${Boost_SYSTEM_LIBRARY_RELEASE}")
        endif()
        add_GUDHI_PYTHON_lib_dir(${Boost_LIBRARY_DIRS})
        message("** Add Boost ${Boost_LIBRARY_DIRS}")
      endif(CGAL_HEADER_ONLY)
      # GMP and GMPXX are not required, but if present, CGAL will link with them.
      if(GMP_FOUND)
        add_gudhi_debug_info("GMP_LIBRARIES = ${GMP_LIBRARIES}")
        set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_USE_GMP', ")
        add_GUDHI_PYTHON_lib("${GMP_LIBRARIES}")
        if(NOT GMP_LIBRARIES_DIR)
          get_filename_component(GMP_LIBRARIES_DIR ${GMP_LIBRARIES} PATH)
          message("GMP_LIBRARIES_DIR from GMP_LIBRARIES set to ${GMP_LIBRARIES_DIR}")
        endif(NOT GMP_LIBRARIES_DIR)
        add_GUDHI_PYTHON_lib_dir(${GMP_LIBRARIES_DIR})
        message("** Add gmp ${GMP_LIBRARIES_DIR}")
        # When FORCE_CGAL_NOT_TO_BUILD_WITH_GMPXX is set, not defining CGAL_USE_GMPXX is sufficient enough
        if(GMPXX_FOUND)
          add_gudhi_debug_info("GMPXX_LIBRARIES = ${GMPXX_LIBRARIES}")
          set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_USE_GMPXX', ")
          add_GUDHI_PYTHON_lib("${GMPXX_LIBRARIES}")
          add_GUDHI_PYTHON_lib_dir(${GMPXX_LIBRARIES_DIR})

=== src/Alpha_complex/test/CMakeLists.txt ===
project(Alpha_complex_tests)

include(GUDHI_boost_test)
if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)

  # Do not forget to copy test files in current binary dir
  file(COPY "${CMAKE_SOURCE_DIR}/data/points/alphacomplexdoc.off" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

  add_executable ( Alpha_complex_test_unit Alpha_complex_unit_test.cpp )
  target_link_libraries(Alpha_complex_test_unit ${CGAL_LIBRARY})
  add_executable ( Alpha_complex_dim3_test_unit Alpha_complex_dim3_unit_test.cpp )
  target_link_libraries(Alpha_complex_dim3_test_unit ${CGAL_LIBRARY})
  add_executable ( Delaunay_complex_test_unit Delaunay_complex_unit_test.cpp )
  target_link_libraries(Delaunay_complex_test_unit ${CGAL_LIBRARY})
  if (TBB_FOUND)
    target_link_libraries(Alpha_complex_test_unit ${TBB_LIBRARIES})
    target_link_libraries(Alpha_complex_dim3_test_unit ${TBB_LIBRARIES})
    target_link_libraries(Delaunay_complex_test_unit ${TBB_LIBRARIES})
  endif()

  gudhi_add_boost_test(Alpha_complex_test_unit)
  gudhi_add_boost_test(Alpha_complex_dim3_test_unit)
  gudhi_add_boost_test(Delaunay_complex_test_unit)

endif (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)

if (NOT CGAL_VERSION VERSION_LESS 4.11.0)

  add_executable ( Alpha_complex_3d_test_unit Alpha_complex_3d_unit_test.cpp )
  target_link_libraries(Alpha_complex_3d_test_unit ${CGAL_LIBRARY})
  add_executable ( Weighted_alpha_complex_3d_test_unit Weighted_alpha_complex_3d_unit_test.cpp )
  target_link_libraries(Weighted_alpha_complex_3d_test_unit ${CGAL_LIBRARY})
  add_executable ( Periodic_alpha_complex_3d_test_unit Periodic_alpha_complex_3d_unit_test.cpp )
  target_link_libraries(Periodic_alpha_complex_3d_test_unit ${CGAL_LIBRARY})
  add_executable ( Weighted_periodic_alpha_complex_3d_test_unit Weighted_periodic_alpha_complex_3d_unit_test.cpp )
  target_link_libraries(Weighted_periodic_alpha_complex_3d_test_unit ${CGAL_LIBRARY})
  if (TBB_FOUND)
    target_link_libraries(Alpha_complex_3d_test_unit ${TBB_LIBRARIES})
    target_link_libraries(Weighted_alpha_complex_3d_test_unit ${TBB_LIBRARIES})
    target_link_libraries(Periodic_alpha_complex_3d_test_unit ${TBB_LIBRARIES})
    target_link_libraries(Weighted_periodic_alpha_complex_3d_test_unit ${TBB_LIBRARIES})
  endif()

  gudhi_add_boost_test(Alpha_complex_3d_test_unit)
  gudhi_add_boost_test(Weighted_alpha_complex_3d_test_unit)
  gudhi_add_boost_test(Periodic_alpha_complex_3d_test_unit)
  gudhi_add_boost_test(Weighted_periodic_alpha_complex_3d_test_unit)

endif (NOT CGAL_VERSION VERSION_LESS 4.11.0)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.1.0)
  add_executable ( Alpha_kernel_d_test_unit Alpha_kernel_d_unit_test.cpp )
  target_link_libraries(Alpha_kernel_d_test_unit ${CGAL_LIBRARY})
  if (TBB_FOUND)
    target_link_libraries(Alpha_kernel_d_test_unit ${TBB_LIBRARIES})
  endif()
  gudhi_add_boost_test(Alpha_kernel_d_test_unit)
  
  add_executable ( Weighted_alpha_complex_test_unit Weighted_alpha_complex_unit_test.cpp )
  target_link_libraries(Weighted_alpha_complex_test_unit ${CGAL_LIBRARY})
  if (TBB_FOUND)
    target_link_libraries(Weighted_alpha_complex_test_unit ${TBB_LIBRARIES})
  endif()
  gudhi_add_boost_test(Weighted_alpha_complex_test_unit)

  add_executable ( Weighted_alpha_complex_non_visible_points_test_unit Weighted_alpha_complex_non_visible_points_unit_test.cpp )
  target_link_libraries(Weighted_alpha_complex_non_visible_points_test_unit ${CGAL_LIBRARY})
  if (TBB_FOUND)
    target_link_libraries(Weighted_alpha_complex_non_visible_points_test_unit ${TBB_LIBRARIES})
  endif()
  gudhi_add_boost_test(Weighted_alpha_complex_non_visible_points_test_unit)

  add_executable ( Zero_weighted_alpha_complex_test_unit Zero_weighted_alpha_complex_unit_test.cpp )
  target_link_libraries(Zero_weighted_alpha_complex_test_unit ${CGAL_LIBRARY})
  if (TBB_FOUND)
    target_link_libraries(Zero_weighted_alpha_complex_test_unit ${TBB_LIBRARIES})
  endif()
  gudhi_add_boost_test(Zero_weighted_alpha_complex_test_unit)

endif (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.1.0)

=== src/Bitmap_cubical_complex/test/CMakeLists.txt ===
project(Bitmap_cubical_complex_tests)

include(GUDHI_boost_test)

# Do not forget to copy test files in current binary dir
file(COPY "${CMAKE_SOURCE_DIR}/data/bitmap/sinusoid.txt" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

add_executable ( Bitmap_cubical_complex_test_unit Bitmap_test.cpp )
if (TBB_FOUND)
  target_link_libraries(Bitmap_cubical_complex_test_unit ${TBB_LIBRARIES})
endif()

gudhi_add_boost_test(Bitmap_cubical_complex_test_unit)

=== src/Bottleneck_distance/example/CMakeLists.txt ===
project(Bottleneck_distance_examples)

if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
  add_executable (bottleneck_basic_example bottleneck_basic_example.cpp)

  if (TBB_FOUND)
    target_link_libraries(bottleneck_basic_example ${TBB_LIBRARIES})
  endif(TBB_FOUND)
  
  add_test(NAME Bottleneck_distance_example_basic COMMAND $<TARGET_FILE:bottleneck_basic_example>)

endif (NOT CGAL_VERSION VERSION_LESS 4.11.0)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)
  if (TARGET Boost::program_options)
    add_executable (alpha_rips_persistence_bottleneck_distance alpha_rips_persistence_bottleneck_distance.cpp)
    target_link_libraries(alpha_rips_persistence_bottleneck_distance Boost::program_options)

    if (TBB_FOUND)
      target_link_libraries(alpha_rips_persistence_bottleneck_distance ${TBB_LIBRARIES})
    endif(TBB_FOUND)

    add_test(NAME Bottleneck_distance_example_alpha_rips_persistence_bottleneck
        COMMAND $<TARGET_FILE:alpha_rips_persistence_bottleneck_distance>
        "${CMAKE_SOURCE_DIR}/data/points/tore3D_1307.off" "-r" "0.15" "-m" "0.12" "-d" "3" "-p" "3")
  endif()
endif (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)

=== src/Bottleneck_distance/test/CMakeLists.txt ===
project(Bottleneck_distance_tests)

if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
  include(GUDHI_boost_test)

  add_executable ( Bottleneck_distance_test_unit bottleneck_unit_test.cpp )
  if (TBB_FOUND)
    target_link_libraries(Bottleneck_distance_test_unit ${TBB_LIBRARIES})
  endif(TBB_FOUND)

  gudhi_add_boost_test(Bottleneck_distance_test_unit)

endif (NOT CGAL_VERSION VERSION_LESS 4.11.0)

=== src/Cech_complex/benchmark/CMakeLists.txt ===
project(Cech_complex_benchmark)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.0.1)
  # Do not forget to copy test files in current binary dir
  file(COPY "${CMAKE_SOURCE_DIR}/data/points/tore3D_1307.off" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

  if(TARGET Boost::filesystem)
    add_executable(cech_complex_benchmark cech_complex_benchmark.cpp)
    target_link_libraries(cech_complex_benchmark Boost::filesystem)
  
    if (TBB_FOUND)
      target_link_libraries(cech_complex_benchmark ${TBB_LIBRARIES})
    endif()
  endif()
endif()

=== src/Cech_complex/example/CMakeLists.txt ===
project(Cech_complex_examples)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.0.1)
  add_executable ( Cech_complex_example_from_points cech_complex_example_from_points.cpp)
  if (TBB_FOUND)
    target_link_libraries(Cech_complex_example_from_points ${TBB_LIBRARIES})
  endif()
  add_test(NAME Cech_complex_example_from_points COMMAND $<TARGET_FILE:Cech_complex_example_from_points>)
endif()

=== src/Cech_complex/test/CMakeLists.txt ===
if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.0.1)
  include(GUDHI_boost_test)

  add_executable ( Cech_complex_test_unit test_cech_complex.cpp )
  if (TBB_FOUND)
    target_link_libraries(Cech_complex_test_unit ${TBB_LIBRARIES})
  endif()

  # Do not forget to copy test files in current binary dir
  file(COPY "${CMAKE_SOURCE_DIR}/data/points/alphacomplexdoc.off" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

  gudhi_add_boost_test(Cech_complex_test_unit)

endif()

=== src/Cech_complex/utilities/CMakeLists.txt ===
if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 5.0.1)
  project(Cech_complex_utilities)

  if (TARGET Boost::program_options)
    add_executable(cech_persistence cech_persistence.cpp)
    target_link_libraries(cech_persistence Boost::program_options)

    if (TBB_FOUND)
      target_link_libraries(cech_persistence ${TBB_LIBRARIES})
    endif()

    add_test(NAME Cech_complex_utility_from_rips_on_tore_3D_safe COMMAND $<TARGET_FILE:cech_persistence>
        "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off" "-r" "0.25" "-m" "0.5" "-d" "3" "-p" "3" "-o" "safe.pers")
    add_test(NAME Cech_complex_utility_from_rips_on_tore_3D_fast COMMAND $<TARGET_FILE:cech_persistence>
        "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off" "-r" "0.25" "-m" "0.5" "-d" "3" "-p" "3" "-o" "fast.pers" "-f")
    add_test(NAME Cech_complex_utility_from_rips_on_tore_3D_exact COMMAND $<TARGET_FILE:cech_persistence>
        "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off" "-r" "0.25" "-m" "0.5" "-d" "3" "-p" "3" "-o" "exact.pers" "-e")

    if (DIFF_PATH)
      add_test(Cech_complex_utilities_diff_exact ${DIFF_PATH}
               "exact.pers" "safe.pers")
      set_tests_properties(Cech_complex_utilities_diff_exact PROPERTIES DEPENDS
               "Cech_complex_utility_from_rips_on_tore_3D_safe;Cech_complex_utility_from_rips_on_tore_3D_exact")

      add_test(Cech_complex_utilities_diff_fast ${DIFF_PATH}
               "fast.pers" "safe.pers")
      set_tests_properties(Cech_complex_utilities_diff_fast PROPERTIES DEPENDS
               "Cech_complex_utility_from_rips_on_tore_3D_safe;Cech_complex_utility_from_rips_on_tore_3D_fast")
    endif()

    install(TARGETS cech_persistence DESTINATION bin)
  endif()
endif()

=== src/Collapse/utilities/CMakeLists.txt ===
project(Collapse_utilities)

if (NOT EIGEN3_VERSION VERSION_LESS 3.1.0)
  if (TARGET Boost::program_options)
    # From a point cloud
    add_executable ( point_cloud_edge_collapse_rips_persistence point_cloud_edge_collapse_rips_persistence.cpp )
    target_link_libraries(point_cloud_edge_collapse_rips_persistence Boost::program_options)
  
    if (TBB_FOUND)
      target_link_libraries(point_cloud_edge_collapse_rips_persistence ${TBB_LIBRARIES})
    endif()
    add_test(NAME Edge_collapse_utilities_point_cloud_rips_persistence COMMAND $<TARGET_FILE:point_cloud_edge_collapse_rips_persistence>
             "${CMAKE_SOURCE_DIR}/data/points/tore3D_1307.off" "-r" "0.25" "-m" "0.5" "-d" "3" "-p" "3" "-o" "off_results.pers")
  
    install(TARGETS point_cloud_edge_collapse_rips_persistence DESTINATION bin)
  
    # From a distance matrix
    add_executable ( distance_matrix_edge_collapse_rips_persistence distance_matrix_edge_collapse_rips_persistence.cpp )
    target_link_libraries(distance_matrix_edge_collapse_rips_persistence Boost::program_options)
  
    if (TBB_FOUND)
      target_link_libraries(distance_matrix_edge_collapse_rips_persistence ${TBB_LIBRARIES})
    endif()
    add_test(NAME Edge_collapse_utilities_distance_matrix_rips_persistence COMMAND $<TARGET_FILE:distance_matrix_edge_collapse_rips_persistence>
             "${CMAKE_SOURCE_DIR}/data/distance_matrix/tore3D_1307_distance_matrix.csv" "-r" "0.25" "-m" "0.5" "-d" "3" "-p" "3" "-o" "csv_results.pers")
  
    install(TARGETS distance_matrix_edge_collapse_rips_persistence DESTINATION bin)
  
    if (DIFF_PATH)
      add_test(Edge_collapse_utilities_diff_persistence ${DIFF_PATH}
               "off_results.pers" "csv_results.pers")
      set_tests_properties(Edge_collapse_utilities_diff_persistence PROPERTIES DEPENDS
                           "Edge_collapse_utilities_point_cloud_rips_persistence;Edge_collapse_utilities_distance_matrix_rips_persistence")
    endif()
  endif()

endif()

=== debian/changelog ===
gudhi (3.7.1+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Drop some more images from DFSG repack.
  * Refresh patches.
  * Drop upstreamed patch for QGLViewer 2.7.
  * Add patch to keep supporting Hera 1.0.
  * Standards-version 4.6.2.0, no changes needed.

 -- Gard Spreemann <gspr@nonempty.org>  Thu, 26 Jan 2023 16:35:52 +0100

gudhi (3.6.0+dfsg-4) unstable; urgency=medium

  * Add patch to support QGLViewer >=2.7. (Closes: 1024061)

 -- Gard Spreemann <gspr@nonempty.org>  Mon, 14 Nov 2022 17:30:15 +0100

gudhi (3.6.0+dfsg-3) unstable; urgency=medium

  * Bump CGAL dependency to >=5.5.1, allowing us to drop the CGAL 5.5
    compatibility patch.

 -- Gard Spreemann <gspr@nonempty.org>  Thu, 03 Nov 2022 16:48:20 +0100

gudhi (3.6.0+dfsg-2) unstable; urgency=medium

  * Fix watch file broken by GitHub change.

 -- Gard Spreemann <gspr@nonempty.org>  Mon, 03 Oct 2022 16:31:23 +0200

=== debian/control ===
Source: gudhi
Maintainer: Gard Spreemann <gspr@nonempty.org>
Section: math
Priority: optional
Standards-Version: 4.6.2.0
Build-Depends: cmake (>= 3.5),
               cython3,
               debhelper-compat (= 13),
               dh-python,
               libboost-filesystem-dev (>= 1.66),
               libboost-program-options-dev (>= 1.66),
               libboost-system-dev (>= 1.66),
               libboost-test-dev (>= 1.66),
               libboost-thread-dev (>= 1.66),
               libboost-timer-dev (>= 1.66),
               libcgal-dev (>= 5.5.1),
               libcgal-qt5-dev (>= 5.5.1),
               libeigen3-dev,
               libgmp-dev,
               libhera-dev (>= 1.0.0),
               libqglviewer-dev-qt5,
               libtbb-dev,
               pybind11-dev,
               python3-all-dev,
               python3-eagerpy,
               python3-matplotlib,
               python3-numpy,
               python3-pot,
               python3-pybind11,
               python3-pytest,
               python3-scipy,
               python3-setuptools,
               python3-sklearn,
               python3-tk,
               qtbase5-dev
Build-Depends-Indep: doxygen,
                     graphviz
Rules-Requires-Root: no
Homepage: https://gudhi.inria.fr/
Vcs-Browser: https://salsa.debian.org/gspr/gudhi
Vcs-Git: https://salsa.debian.org/gspr/gudhi.git -b debian/sid

Package: libgudhi-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: libboost-filesystem-dev (>= 1.66),
         libboost-program-options-dev (>= 1.66),
         libboost-system-dev (>= 1.66),
         libboost-test-dev (>= 1.66),
         libboost-thread-dev (>= 1.66),
         libboost-timer-dev (>= 1.66),
         libcgal-dev (>= 5.5.1),
         libeigen3-dev (>= 3.1.0),
         libgmp-dev (>= 4.2),
         libtbb-dev,
         ${misc:Depends}
Suggests: libgudhi-doc, libgudhi-examples, libhera-dev
Description: Generic open source C++ library for topological data analysis
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains the header files. See the libgudhi-examples
 package for example programs using the library.

Package: libgudhi-examples
Section: misc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libgudhi-dev, libgudhi-doc
Description: Example programs for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains some source code examples.

Package: libgudhi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-mathjax, ${misc:Depends}
Description: Documentation for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains documentation.

Package: python3-gudhi
Section: python
Architecture: amd64 arm64 i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 x32
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Recommends: python3-eagerpy,
            python3-matplotlib,
            python3-pot,
            python3-scipy,
            python3-sklearn
Description: Python 3 interface to the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains GUDHI's Python (3) interface.

Package: gudhui
Section: math
Architecture: amd64 arm64 i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 x32
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: GUI for some of the functionality of the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains GudhUI, a graphical interface to a few of GUDHI's
 features. Be aware that it is quite rough around the edges.

Package: gudhi-utils
Section: math
Architecture: amd64 arm64 i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 x32
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Utilities from the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 This package contains some utilities built with the GUDHI library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

TMPBIN:=debian/tmp/usr/bin

PY3VERS:=$(shell py3versions -vs)

DHFLAGS+=--buildsystem=cmake

# To fix #945226, we turn off parallel builds everywhere, except if
# someone explicitly wants them enabled by setting the environment
# variable ALLOW_PARALLEL.
ifeq (, $(ALLOW_PARALLEL))
	DHFLAGS+=--no-parallel
endif

# The buildds run out of memory on some architectures. On those, we
# tune the GCC garbage collector and force non-parallel building.
ifneq (, $(filter $(shell dpkg-architecture --query DEB_BUILD_ARCH),armhf arm64 i386 mips mipsel m68k powerpcspe x32))
	export DEB_CXXFLAGS_MAINT_APPEND = --param ggc-min-expand=5
# We have disabled parallel builds in general now. Consider disabling
# for certain architectures if it's reenabled globally.
#	DHFLAGS+=--no-parallel
endif

# Disable tests on i386 due to rounding problem in some. See upstream GitHub issue #118.
ifneq (, $(filter $(shell dpkg-architecture --query DEB_BUILD_ARCH),i386 x32))
	export DEB_BUILD_MAINT_OPTIONS := $(DEB_BUILD_MAINT_OPTIONS) nocheck
endif

%:
	dh $@ $(DHFLAGS) --with=python3

execute_before_dh_auto_configure:
	dh_auto_configure $(DHFLAGS) --builddirectory=build -- -DWITH_GUDHI_BENCHMARK=true -DWITH_GUDHI_EXAMPLE=true -DWITH_GUDHI_PYTHON=false -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=true -DWITH_GUDHI_REMOTE_TEST=false -DUSER_VERSION_DIR=userversion -DHERA_INCLUDE_DIR=/usr/include/hera
	make -C build user_version
	for py3ver in $(PY3VERS) ; do \
		dh_auto_configure $(DHFLAGS) --builddirectory=build-py$$py3ver -- -DWITH_GUDHI_BENCHMARK=false -DWITH_GUDHI_EXAMPLE=false -DWITH_GUDHI_PYTHON=true -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=false -DWITH_GUDHI_REMOTE_TEST=false -DPython_ADDITIONAL_VERSIONS=$$py3ver -DUSER_VERSION_DIR=userversion -DWITH_GUDHI_PYTHON_RUNTIME_LIBRARY_DIRS=false -DHERA_INCLUDE_DIR=/usr/include/hera ; \
		make -C build-py$$py3ver user_version ; \
	done

override_dh_auto_configure:
	dh_auto_configure $(DHFLAGS) --sourcedir=build/userversion --builddirectory=build/userversion/build -- -DWITH_GUDHI_BENCHMARK=true -DWITH_GUDHI_EXAMPLE=true -DWITH_GUDHI_PYTHON=false -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=true -DWITH_GUDHI_REMOTE_TEST=false -DHERA_INCLUDE_DIR=/usr/include/hera
	for py3ver in $(PY3VERS) ; do \
		dh_auto_configure $(DHFLAGS) --sourcedir=build-py$$py3ver/userversion --builddirectory=build-py$$py3ver/userversion/build -- -DWITH_GUDHI_BENCHMARK=false -DWITH_GUDHI_EXAMPLE=false -DWITH_GUDHI_PYTHON=true -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=false -DWITH_GUDHI_REMOTE_TEST=false -DPython_ADDITIONAL_VERSIONS=$$py3ver -DWITH_GUDHI_PYTHON_RUNTIME_LIBRARY_DIRS=false -DHERA_INCLUDE_DIR=/usr/include/hera ; \
	done

override_dh_auto_build-arch:
	dh_auto_build $(DHFLAGS) --sourcedir=build/userversion --builddirectory=build/userversion/build
	for py3ver in $(PY3VERS) ; do \
		cd build-py$$py3ver/userversion/build/python ; \
		/usr/bin/python$$py3ver setup.py build ; \
	done

override_dh_auto_build-indep:
	cd build/userversion/build ; \
	make doxygen

override_dh_auto_test-indep:

override_dh_auto_test-arch:
# I believe this should be handled automatically by dh_auto_test,
# but see #901678.
ifeq (, $(filter nocheck,$(DEB_BUILD_MAINT_OPTIONS)))
	dh_auto_test $(DHFLAGS) --no-parallel --sourcedir=build/userversion --builddirectory=build/userversion/build
else
	@echo "Skipping tests due to nocheck flag."
endif

override_dh_auto_install-arch:
	dh_auto_install $(DHFLAGS) --sourcedir=build/userversion --builddirectory=build/userversion/build
	for py3ver in $(PY3VERS) ; do \
		cd build-py$$py3ver/userversion/build/python ; \
		/usr/bin/python$$py3ver setup.py install --root=../../../../debian/tmp --single-version-externally-managed --install-layout=deb ; \
	done

	mv $(TMPBIN)/Nerve \
	   $(TMPBIN)/gudhi-nerve
	mv $(TMPBIN)/VoronoiGIC \
	   $(TMPBIN)/gudhi-voronoi-gic
	mv $(TMPBIN)/Witness_complex_strong_witness_persistence \
	   $(TMPBIN)/gudhi-witness-complex-strong-witness-persistence
	mv $(TMPBIN)/Witness_complex_weak_witness_persistence \
	   $(TMPBIN)/gudhi-witness-complex-weak-witness-persistence
	mv $(TMPBIN)/alpha_complex_3d_persistence \
	   $(TMPBIN)/gudhi-alpha-complex-3d-persistence
	mv $(TMPBIN)/alpha_complex_persistence \
	   $(TMPBIN)/gudhi-alpha-complex-persistence
	mv $(TMPBIN)/bottleneck_distance \
	   $(TMPBIN)/gudhi-bottleneck-distance
	mv $(TMPBIN)/cech_persistence \
	   $(TMPBIN)/gudhi-cech-persistence
	mv $(TMPBIN)/cubical_complex_persistence \
	   $(TMPBIN)/gudhi-cubical-complex-persistence
	mv $(TMPBIN)/off_file_from_shape_generator \
	   $(TMPBIN)/gudhi-off-file-from-shape-generator
	mv $(TMPBIN)/periodic_cubical_complex_persistence \
	   $(TMPBIN)/gudhi-periodic-cubical-complex-persistence
	mv $(TMPBIN)/rips_correlation_matrix_persistence \
	   $(TMPBIN)/gudhi-rips-correlation-matrix-persistence
	mv $(TMPBIN)/rips_distance_matrix_persistence \
	   $(TMPBIN)/gudhi-rips-distance-matrix-persistence
	mv $(TMPBIN)/rips_persistence \
	   $(TMPBIN)/gudhi-rips-persistence
	mv $(TMPBIN)/sparse_rips_persistence \
	   $(TMPBIN)/gudhi-sparse-rips-persistence
	mv $(TMPBIN)/distance_matrix_edge_collapse_rips_persistence \
	   $(TMPBIN)/gudhi-distance-matrix-edge-collapse-rips-persistence
	mv $(TMPBIN)/point_cloud_edge_collapse_rips_persistence \
	   $(TMPBIN)/gudhi-point-cloud-edge-collapse-rips-persistence

	mv $(TMPBIN)/GudhUI $(TMPBIN)/gudhui

override_dh_auto_install-indep:
	find src -type f -path '*/example/*' \( -name '*.cpp' -o \( -name '*.txt' -a ! -iname 'cmake*' \) \) -exec sh -c 'name=$$(echo $$0 | sed s/src\\/// | sed s/example\\///); install -D -m 644 $$0 debian/tmp/usr/share/doc/libgudhi-examples/$$name' {} \;

override_dh_compress:
	dh_compress -X.cpp

override_dh_install:
	dh_install -X__pycache__ -X.pyc -X.pyo

override_dh_missing:
	dh_missing --list-missing

override_dh_python3:
	for py3ver in $(PY3VERS) ; do \
		dh_python3 -O--sourcedir=build-py$$py3ver/userversion ; \
	done

execute_before_dh_auto_clean:
	rm -rf build
	for py3ver in $(PY3VERS) ; do \
		rm -rf build-py$$py3ver ; \
	done
